package com.bjsxt.plane;

import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Date;

public class MyGameFrame extends Frame {

    Image planeImg = GameUtil.getImage("images/plane.png");
    Image bg = GameUtil.getImage("images/bg.jpg");

    Plane p1 = new Plane(planeImg,300,300,6);
    //Shell s1 = new Shell();
    Shell[] shells = new Shell[30];
    Explode explode;//爆炸
    Date start= new Date();//游戏开始时间
    Date end;//结束时间
    int period=0;//玩了多少秒

    @Override
    public void paint(Graphics g) {//当作一支画笔
        g.drawImage(bg,0,0,500,500,null);



        p1.drawMyself(g);//画飞机

        //画炮弹
        //s1.drawMyself(g);
        for(int i=0;i<shells.length;i++){
            shells[i].drawMyself(g);
            boolean peng = shells[i].getRect().intersects(p1.getRect());
            if (peng){
                System.out.println("被击中");
                p1.live = false;
                if(explode==null){
                    explode = new Explode(p1.x,p1.y);
                    explode.drawMySelf(g);
                }
            }
        }

    }
    public void drawTime(Graphics g){
        Color c = g.getColor();
        Font f= g.getFont();
        g.setColor(Color.green);
        if (p1.live){
            period = (int) (System.currentTimeMillis() - start.getTime())/1000;
            g.drawString("时间:"+period,30,50);
        }else{
            if (end==null){
                end = new Date();
                period = (int) (end.getTime() - start.getTime())/1000;
            }
            g.setColor(Color.red);
            g.setFont(new Font("微软雅黑",Font.BOLD,30));
            g.drawString("最终时间："+period,200,200);
        }
        g.setColor(c);
        g.setFont(f);
    }

    //初始化窗口
    public void launchFrame(){
        this.setTitle("尚学堂-飞机大战");//窗口名
        setVisible(true);//可见
        setSize(Constant.GAME_WIDTH,Constant.GAME_HEIGHT);//窗口大小
        setLocation(100,100);
        //关闭窗口
        this.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                System.exit(0);//退出程序  0正常退出  -1异常关闭
            }
        });
        new PaintThread().start();//启动线程

        this.addKeyListener(new KeyMonitor());//启动监听

        //
        for (int i=0;i<30;i++){
            shells[i] =new Shell();
        }
    }

    /**
     * 定义了一个窗口的线程类
     * 定义成内部类为了直接使用窗口类的相关方法
     */
    class PaintThread extends Thread{
        @Override
        public void run() {
            while (true){
                repaint();//内部类可以直接用外部类的成员
                try {
                    Thread.sleep(40);//1s=1000ms， 1s画20次
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
    //内部类，实现键盘的监听处理
    class KeyMonitor extends KeyAdapter{
        @Override
        public void keyPressed(KeyEvent e) {
//            System.out.println("安下："+e.getKeyCode());
            p1.addDirection(e);
        }

        @Override
        public void keyReleased(KeyEvent e) {
//            System.out.println("放开："+e.getKeyCode());
            p1.minusDirection(e);
        }
    }

    private Image offScreenImage = null;	//利用双缓冲消除闪烁
    public void update(Graphics g){
        if(offScreenImage == null)
            offScreenImage = this.createImage(Constant.GAME_WIDTH,Constant.GAME_HEIGHT);
        Graphics gOff = offScreenImage.getGraphics();
        paint(gOff);
        g.drawImage(offScreenImage, 0 , 0 , null);
    }

    public static void main(String[] args) {
        MyGameFrame gameFrame = new MyGameFrame();
        gameFrame.launchFrame();
    }
}
